using System;
using Microsoft.DirectX.Direct3D;

namespace blue_dish_te
{
	// obecna trida pro objekty na mape
	internal class MapObject
	{
		public float renderTime;
		protected Device device;
		protected DatLoader dat;

		protected char type;
		protected Svet svet;
		public bool noTexture = false;

		protected int objectX;
		protected int objectY;

		// konstruktor
		public MapObject(Device dev, DatLoader dat) : this(dev, dat, ' ')
		{
		}

		public MapObject(Device dev, DatLoader dat, char type)
		{
			device = dev;
			this.dat = dat;
			this.type = type;
		}

		protected MapObject()
		{
			throw new NotImplementedException();
		}

		// vola se pokud je pouzit object klavesou
		public virtual void UseObject()
		{
		}

		// renderovaci funkce
		public virtual void Render()
		{
			throw new NotImplementedException();
		}

		// hrac prisel na kosticku s objektem
		public virtual bool PlayerOver()
		{
			return false;
		}

		// hrac opustil kosticku s objektem
		public virtual bool PlayerOut()
		{
			return false;
		}

		// reseni kolizi
		public virtual bool DetectCollision()
		{
			return false;
		}

		// nastaveni sveta
		public virtual void setSvet(Svet svet)
		{
			this.svet = svet;
		}

		// nastaveni pozice objektu
		public void setObjectPos(int x, int y)
		{
			objectX = x;
			objectY = y;
		}
	}
}